(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["logscribe"] = factory();
	else
		root["logscribe"] = factory();
})(global, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(__dirname) {
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __webpack_require__(1);
var path = __webpack_require__(2);
// Testing environment doesn't understand require.main and such.
var isTesting = "production" === 'testing';
if (!isTesting) {
    __webpack_require__.c[__webpack_require__.s] = process.mainModule;
}
// AppDir holds directory path to the application's root.
var appDir = isTesting
    ? path.resolve(__dirname)
    : path.dirname( true && __webpack_require__.c[__webpack_require__.s] ? __webpack_require__.c[__webpack_require__.s].filename : '');
// Here we will store ids of async Promises so that the logging will happen in order.
// Prioritize the user's application 1st!
var buffer = [];
var dateBuffer = [];
// Settings -------------------------------------------------------------------
// These are the so called global settings.
// User can modify these on file-basis.
var settings = {
    logDirPath: appDir,
    logMaxSize: 1024000,
    logPrefix: 'application',
    printDisabled: false,
    printTagColor: '\x1b[36m',
};
// Used to search for existing log files.
var regExp = new RegExp("^" + settings.logPrefix + "_.*log", 'g');
// LogScribe utility methods --------------------------------------------------
/**
 * Returns a tag that is suitable for printting.
 * @param {string} tag - A tag to be printed.
 * @param {color} color - Color of the tag text.
 * @returns {string} - A formatted tag.
 */
exports.getTagForPrint = function (tag, color) {
    try {
        return "" + (color || settings.printTagColor) + tag + "\u001B[0m -";
    }
    catch (_a) {
        return ' -';
    }
};
/**
 * Returns a tag that is suitable for logging.
 * @param {string} tag - A tag to be logged.
 * @returns {string} - A formatted tag.
 */
exports.getTagForLog = function (tag) {
    try {
        return typeof tag === 'string' && tag !== '' ? "[" + tag + "]" : '[]';
    }
    catch (_a) {
        return '[]';
    }
};
/**
 * Does the actual log writing.
 * Writes everything in buffer to log files and then clears the buffer.
 */
var writeBufferToLog = function (files, index, existingPath) {
    try {
        // We can't combine finding with executeBuffer() at it may be that the
        // previous entry in buffer was humongous and the size is now fulfilled.
        var filepath_1 = '';
        if (existingPath) {
            // We already have a suitable filepath.
            filepath_1 = existingPath;
        }
        else {
            filepath_1 =
                settings.logDirPath + "\\" + settings.logPrefix + "_" +
                    (dateBuffer[index].getFullYear() + "-") +
                    (dateBuffer[index].getMonth() + "-") +
                    (dateBuffer[index].getDate() + "-") +
                    (dateBuffer[index].getTime() + ".log");
        }
        fs.appendFile(filepath_1, buffer[index], 'utf8', function (aErr) {
            if (aErr) {
                // Something went wrong, clear the buffer to start fresh
                // next time.
                buffer = [];
                dateBuffer = [];
            }
            else if (buffer[index + 1]) {
                // We measure the file size after the addition
                // to determine whether this same file can be re-used
                // for the next buffer entry. This should save us some cycles.
                fs.stat(filepath_1, function (err, stat) {
                    if (err) {
                        buffer = [];
                        dateBuffer = [];
                    }
                    else if (stat.size < settings.logMaxSize) {
                        // We skip executeBuffer to save performance.
                        // In theory some of the files may have gotten deleted,
                        // but that should be super rare as the buffer clears so fast and
                        // no-one else should be removing our log files after all.
                        writeBufferToLog(files, index + 1, filepath_1);
                    }
                    else {
                        writeBufferToLog(files, index + 1);
                    }
                });
            }
            else {
                // Buffer is executed, clear it.
                buffer = [];
                dateBuffer = [];
            }
        });
        return;
    }
    catch (_a) {
        return;
    }
};
/**
 * Starts to executing the buffer.
 * Buffer contains all the log messages that need to be logged.
 *
 * We shall gather all suitable log files here before we start,
 * this way we don't have to sacrifice performance on finding
 * files on each buffer index.
 */
var executeBuffer = function () {
    fs.readdir(settings.logDirPath, function (err, items) {
        if (err) {
            // Something went wrong, clear the buffer to start fresh
            // next time.
            buffer = [];
            dateBuffer = [];
        }
        else if (items[0]) {
            var files_1 = items.filter(function (f) { return regExp.test(f); });
            if (files_1[0]) {
                var findStat_1 = function (i) {
                    fs.stat(files_1[i], function (errStat, stat) {
                        if (errStat) {
                            // Something went wrong.
                            buffer = [];
                            dateBuffer = [];
                        }
                        else if (stat.size < settings.logMaxSize) {
                            // Bling! A suitable file was found.
                            writeBufferToLog(files_1, 0, files_1[i]);
                        }
                        else if (files_1[i + 1]) {
                            // Read more stats.
                            findStat_1(i + 1);
                        }
                        else {
                            // A new path must be created.
                            writeBufferToLog(files_1, 0);
                        }
                    });
                };
                findStat_1(0);
            }
            else {
                // No existing log files.
                writeBufferToLog([], 0);
            }
        }
        else {
            // Empty dir.
            writeBufferToLog([], 0);
        }
    });
};
// LogScribe public methods ---------------------------------------------------
/**
 * Logs text to a log file.
 * @param payload - A message to log.
 * @returns {Promise<string>} - A message that was saved.
 */
exports.log = function () {
    var payload = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        payload[_i] = arguments[_i];
    }
    try {
        var m_1 = '';
        // Combine the message. Remember, join() would be heavy.
        payload.forEach(function (v) { return (m_1 += v + "\n"); });
        if (!buffer[0]) {
            dateBuffer.push(new Date());
            buffer.push(dateBuffer[0] + "\n" + m_1 + "\n");
            executeBuffer();
        }
        else {
            var d = new Date();
            dateBuffer.push(d);
            buffer.push(d + "\n" + m_1 + "\n");
        }
    }
    catch (_a) {
        return;
    }
};
// Alias to log().
exports.l = exports.log;
/**
 * Prints text to console.
 * @param payload - A message to print.
 */
exports.print = function () {
    var payload = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        payload[_i] = arguments[_i];
    }
    try {
        if (settings.printDisabled) {
            // If printing is disabled, don't print.
            return;
        }
        var d = new Date();
        console.log.apply(console, [('0' + d.getHours()).slice(-2) + ":" +
                (('0' + d.getMinutes()).slice(-2) + ":") +
                ("" + ('0' + d.getSeconds()).slice(-2))].concat(payload));
    }
    catch (_a) {
        return;
    }
};
// Alias to print().
exports.p = exports.print;
/**
 * Logs and prints a message.
 * A combination of log() and print().
 * @param payload - A message to print and log.
 */
exports.logprint = function () {
    var payload = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        payload[_i] = arguments[_i];
    }
    try {
        exports.print.apply(void 0, payload);
        exports.log.apply(void 0, payload);
    }
    catch (_a) {
        return;
    }
};
// Alias to logprint();
exports.lp = exports.logprint;
// LogScribe private methods --------------------------------------------------
/**
 * Used to enable logprint with a tag.
 * @param tag - A tag to be printed.
 * @param payload - A message to print and log.
 */
var logprintWithTag = function (tag) {
    var payload = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        payload[_i - 1] = arguments[_i];
    }
    try {
        exports.print.apply(void 0, [exports.getTagForPrint(tag)].concat(payload));
        exports.log.apply(void 0, [exports.getTagForLog(tag)].concat(payload));
    }
    catch (_a) {
        return;
    }
};
/**
 * Sets default directory path for the log files.
 * @param {string} value - A new value to be saved.
 */
exports.setLogDirPath = function (value) {
    try {
        settings.logDirPath = String(value);
    }
    catch (_a) {
        return;
    }
};
/**
 * Sets maximum size for the log files (1000 = 1KB).
 * @param {string} value - A new value to be saved.
 */
exports.setLogMaxSize = function (value) {
    try {
        settings.logMaxSize = Number(value);
    }
    catch (_a) {
        return;
    }
};
/**
 * Sets prefix for the log files (e.g. application_).
 * @param {string} value - A new value to be saved.
 */
exports.setLogPrefix = function (value) {
    try {
        settings.logPrefix = String(value);
        regExp = new RegExp("^" + settings.logPrefix + "_.*log", 'g');
    }
    catch (_a) {
        return;
    }
};
/**
 * Disables printing.
 * @param {string} value - A new value to be saved.
 */
exports.setPrintDisabled = function (value) {
    try {
        settings.printDisabled = Boolean(value);
    }
    catch (_a) {
        return;
    }
};
/**
 * Returns everything this module has to provide but with a
 * global tag attached.
 * @param tag - A tag to be logged.
 * @param color A tag color to be used, e.g. "\x1b[36m".
 */
exports.logscribe = function (tag, color) {
    return {
        l: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return exports.log.apply(void 0, [exports.getTagForLog(tag)].concat(payload));
        },
        log: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return exports.log.apply(void 0, [exports.getTagForLog(tag)].concat(payload));
        },
        logprint: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return logprintWithTag.apply(void 0, [tag].concat(payload));
        },
        lp: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return logprintWithTag.apply(void 0, [tag].concat(payload));
        },
        p: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return exports.print.apply(void 0, [exports.getTagForPrint(tag, color)].concat(payload));
        },
        print: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return exports.print.apply(void 0, [exports.getTagForPrint(tag, color)].concat(payload));
        },
    };
};
exports.default = exports.logscribe;

/* WEBPACK VAR INJECTION */}.call(this, "/"))

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("fs");

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("path");

/***/ })
/******/ ]);
});